package constant.yysdk.com.main_yy_rh_sdk;


import android.app.Activity;


import android.content.Intent;


import android.content.res.Configuration;
import android.net.Uri;

import android.os.Bundle;


import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ScrollView;
import android.widget.Toast;


import com.yyrh.constant.RoleInfo;


import com.yyrh.constant.SDKSettings;
import com.yyrh.easypermission.EasyPermission;
import com.yyrh.easypermission.GrantResult;
import com.yyrh.easypermission.Permission;
import com.yyrh.easypermission.PermissionRequestListener;

import com.yyrh.sdk.callback.UserPolicyCallback;


import com.yyrh.constant.Constants;

import com.yyrh.sdk.SDKEntry;
import com.yyrh.sdk.callback.ExitCallback;
import com.yyrh.sdk.callback.InitCallback;
import com.yyrh.sdk.callback.LoginCallback;
import com.yyrh.sdk.callback.LogoutCallback;
import com.yyrh.sdk.callback.PayCallback;
import com.yyrh.utils.YYLog;


import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;


public class MainActivity extends Activity implements View.OnClickListener {

    private EditText et_hasgold;
    private EditText et_money;
    private EditText et_partyid;
    private EditText et_partyname;
    private EditText et_reincarnationrCount;
    private EditText et_rolectime;
    private EditText et_roleid;
    private EditText et_rolelevel;
    private EditText et_rolename;
    private EditText et_rolepower;
    private EditText et_rolesex;
    private EditText et_serveid;
    private EditText et_servername;
    private EditText et_viplevel;
    private EditText et_charge;
    private boolean isDebug = true;
    private Button logOut;
    private Button login_btn;
    private Button pay_btn;
    private Button permission;
    private SDKEntry sdk;
    private Button upload_btn;
    private Button upload_btn1;
    private Button upload_btn2;
    private Button userCenter;


    @Override
    protected void onCreate(final Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        Log.d("test11111", "1111:" + this.toString());
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        //隐藏顶部状态栏
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);

        setContentView(R.layout.activity_main);

        ScrollView ll = findViewById(R.id.scl_1);

        this.login_btn = (Button) findViewById(R.id.login_btn);
        this.upload_btn = (Button) findViewById(R.id.upload_btn);
        this.upload_btn1 = (Button) findViewById(R.id.upload_btn1);
        this.upload_btn2 = (Button) findViewById(R.id.upload_btn2);
        this.pay_btn = (Button) findViewById(R.id.pay_btn);
        this.logOut = (Button) findViewById(R.id.logout_btn);
        this.userCenter = (Button) findViewById(R.id.user_btn);
        this.permission = (Button) findViewById(R.id.permission);
        this.et_roleid = (EditText) findViewById(R.id.et_roleid);
        this.et_rolename = (EditText) findViewById(R.id.et_rolename);
        this.et_rolelevel = (EditText) findViewById(R.id.et_rolelevel);
        this.et_rolesex = (EditText) findViewById(R.id.et_rolesex);
        this.et_serveid = (EditText) findViewById(R.id.et_serveid);
        this.et_servername = (EditText) findViewById(R.id.et_servername);
        this.et_hasgold = (EditText) findViewById(R.id.et_hasgold);
        this.et_viplevel = (EditText) findViewById(R.id.et_viplevel);
        this.et_partyname = (EditText) findViewById(R.id.et_partyname);
        this.et_partyid = (EditText) findViewById(R.id.et_partyid);
        this.et_rolectime = (EditText) findViewById(R.id.et_rolectime);
        this.et_rolepower = (EditText) findViewById(R.id.et_rolepower);
        this.et_reincarnationrCount = (EditText) findViewById(R.id.et_reincarnationrCount);
        this.et_money = (EditText) findViewById(R.id.et_money);
        this.et_charge = findViewById(R.id.et_charge);
        this.upload_btn.setOnClickListener(this);
        this.upload_btn1.setOnClickListener(this);
        this.upload_btn2.setOnClickListener(this);
        this.pay_btn.setOnClickListener(this);
        this.logOut.setOnClickListener(this);
        this.userCenter.setOnClickListener(this);
        this.permission.setOnClickListener(this);
        this.login_btn.setOnClickListener(this);


        sdk = SDKEntry.getSdkInstance();
        sdk.showPrivacyPolicy(this, new UserPolicyCallback() {
            @Override
            public void onAgree() {
                //用户同意隐私政策，执行初始化相关操作
                init(savedInstanceState);
            }

            @Override
            public void onDisagree() {
                //用户不用同意隐私政策，游戏方关闭游戏操作
                finish();
            }

            @Override
            public void onHide() {
                //不需要对用户显示隐私政策内容，直接进入游戏
                init(savedInstanceState);
            }

            @Override
            public void onError() {
                //接口请求发生错误
                finish();
            }
        });


    }


    private void init(Bundle savedInstanceState) {
        //正式上线，需把isDebug 设置为false
        ArrayList<String> list = new ArrayList(Arrays.asList(Permission.RECORD_AUDIO));
        sdk.setExtPermission(list);
        sdk.initSdk(this, new InitCallback() {
            @Override
            public void onInitSuccess(String msg) {
                Toast.makeText(MainActivity.this, msg, Toast.LENGTH_SHORT)
                        .show();
            }

            @Override
            public void onInitFailed(String msg) {
                Toast.makeText(MainActivity.this, msg, Toast.LENGTH_SHORT)
                        .show();
            }

            @Override
            public void onInitError(String _strError) {
                Toast.makeText(MainActivity.this, _strError, Toast.LENGTH_SHORT)
                        .show();
            }

            @Override
            public void onGetOaid(boolean isSuccess, String oaid) {

            }

            @Override
            public void onShowGameExit() {

            }
        }, isDebug);
        sdk.sdkOnCreate(this, savedInstanceState);
        sdk.setSDKLogoutListener(this, new LogoutCallback() {
            @Override
            public void onLogoutSuccess() {
                Toast.makeText(MainActivity.this, "退出成功", Toast.LENGTH_LONG)
                        .show();
            }

            @Override
            public void onLogoutFailed() {

            }
        });

    }

    @Override
    public void onClick(View view) {
        int id = view.getId();
        if (id == R.id.pay_btn) {
            HashMap hashMap = new HashMap();
            String obj = this.et_money.getText().toString();
            if (judgeStrNull(obj)) {
                Toast.makeText(this, "输入金额不能为空", 1).show();
                return;
            }


            int[] order_split = new int[]{1, 2, 3};

            hashMap.put("order_split", order_split);

            hashMap.put("role_id", this.et_roleid.getText().toString());
            hashMap.put("role_name", this.et_rolename.getText().toString());
            hashMap.put("role_level", this.et_rolelevel.getText().toString());
            hashMap.put("server_id", this.et_serveid.getText().toString());
            hashMap.put("server_name", this.et_servername.getText().toString());
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append(System.currentTimeMillis());
            stringBuilder.append("");
            hashMap.put("game_no", stringBuilder.toString());
            hashMap.put("pay_money", obj);
            hashMap.put("order_desc", "购买10元宝");
            hashMap.put("order_name", "111");
            hashMap.put("product_name", "钻石");
            hashMap.put("productId", "1020122152");
            hashMap.put("ext", "111");
            hashMap.put("vip_level", this.et_viplevel.getText().toString());
            hashMap.put("count", "商品数量");
            hashMap.put("radio", "商品数量与rmb比例");
            hashMap.put("reincarnationCount", "0");
            this.sdk.pay(hashMap, new PayCallback() {
                public void onPaySuccess(String str) {
                    Toast.makeText(MainActivity.this, str, 1).show();
                }

                public void onPayFailed(String str) {
                    Toast.makeText(MainActivity.this, str, 1).show();
                }
            }, this);
        } else if (id != R.id.permission) {
            switch (id) {
                case R.id.login_btn /*2131034177*/:
                    /**
                     AutoLoginDialog.Builder builder = new AutoLoginDialog.Builder(this);
                     builder.setPositiveButton(new DialogInterface.OnClickListener() {
                    @Override public void onClick(DialogInterface dialog, int which) {
                    //取消回调
                    dialog.dismiss();


                    }
                    }).setCloseDialogCallback(new AutoLoginDialog.CloseDialogCallback(){

                    @Override public void onclose() {

                    }
                    });

                     builder.Create().show();

                     Intent intent = new Intent(this, UseLoginActivity.class);
                     //intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                     intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
                     intent.putExtra("isLandscape", Utils.isLandscape(this));
                     this.startActivity(intent);
                     **/
                    sdk.login(this, new LoginCallback() {
                        @Override
                        public void onLoginSuccess(String token) {
                            Toast.makeText(MainActivity.this, token, Toast.LENGTH_SHORT)
                                    .show();

                        }

                        @Override
                        public void onLoginFailed(String msg) {

                        }

                        @Override
                        public void onLoginError(String msg) {

                        }
                    });


                    break;
                case R.id.logout_btn /*2131034178*/:
                    sdk.logout();
                    break;
                default:
                    RoleInfo roleInfo;
                    StringBuilder stringBuilder2;
                    switch (id) {
                        case R.id.upload_btn /*2131034222*/:
                            roleInfo = new RoleInfo();
                            roleInfo.setRoleId(this.et_roleid.getText().toString());
                            roleInfo.setRoleName(this.et_rolename.getText().toString());
                            roleInfo.setRoleLevel(this.et_rolelevel.getText().toString());
                            roleInfo.setGender(this.et_rolesex.getText().toString());
                            roleInfo.setServerId(this.et_serveid.getText().toString());
                            roleInfo.setServerName(this.et_servername.getText().toString());
                            roleInfo.setHasGold(this.et_hasgold.getText().toString());
                            roleInfo.setVipLevel(this.et_viplevel.getText().toString());
                            roleInfo.setRolePower("7653471597");

                            roleInfo.setPartyId(this.et_partyid.getText().toString());
                            roleInfo.setPartyName(this.et_partyname.getText().toString());
                            roleInfo.setRoleCreateTime(this.et_rolectime.getText().toString());
                            roleInfo.setPartyId(this.et_partyid.getText().toString());
                            roleInfo.setReincarnationCount(this.et_reincarnationrCount.getText().toString());
                            roleInfo.setCharge(et_charge.getText().toString());
                            this.sdk.upLoadRoleInfo(Constants.UPLOADTYPE_CREATEROLE, this, roleInfo);

                            break;
                        case R.id.upload_btn1 /*2131034223*/:
                            roleInfo = new RoleInfo();
                            roleInfo.setRoleId(this.et_roleid.getText().toString());
                            roleInfo.setRoleName(this.et_rolename.getText().toString());
                            roleInfo.setRoleLevel(this.et_rolelevel.getText().toString());
                            roleInfo.setGender(this.et_rolesex.getText().toString());
                            roleInfo.setServerId(this.et_serveid.getText().toString());
                            roleInfo.setServerName(this.et_servername.getText().toString());
                            roleInfo.setHasGold(this.et_hasgold.getText().toString());
                            roleInfo.setVipLevel(this.et_viplevel.getText().toString());
                            roleInfo.setRolePower("7653471597");

                            roleInfo.setPartyId(this.et_partyid.getText().toString());
                            roleInfo.setPartyName(this.et_partyname.getText().toString());
                            roleInfo.setRoleCreateTime(this.et_rolectime.getText().toString());
                            roleInfo.setPartyId(this.et_partyid.getText().toString());
                            roleInfo.setReincarnationCount(this.et_reincarnationrCount.getText().toString());
                            roleInfo.setCharge(et_charge.getText().toString());
                            this.sdk.upLoadRoleInfo(Constants.UPLOADTYPE_ENTERGAME, this, roleInfo);
                            stringBuilder2 = new StringBuilder();
                            stringBuilder2.append("roleInfo:=");
                            stringBuilder2.append(roleInfo.getAllParam().toString());
                            Toast.makeText(this, stringBuilder2.toString(), Toast.LENGTH_LONG).show();

                            break;
                        case R.id.upload_btn2 /*2131034224*/:
                            roleInfo = new RoleInfo();
                            roleInfo.setRoleId(this.et_roleid.getText().toString());
                            roleInfo.setRoleName(this.et_rolename.getText().toString());
                            roleInfo.setRoleLevel(this.et_rolelevel.getText().toString());
                            roleInfo.setGender(this.et_rolesex.getText().toString());
                            roleInfo.setServerId(this.et_serveid.getText().toString());
                            roleInfo.setServerName(this.et_servername.getText().toString());
                            roleInfo.setHasGold(this.et_hasgold.getText().toString());
                            roleInfo.setVipLevel(this.et_viplevel.getText().toString());
                            roleInfo.setRolePower(this.et_rolepower.getText().toString());
                            roleInfo.setPartyId(this.et_partyid.getText().toString());
                            roleInfo.setPartyName(this.et_partyname.getText().toString());
                            roleInfo.setRoleCreateTime(this.et_rolectime.getText().toString());
                            roleInfo.setPartyId(this.et_partyid.getText().toString());
                            roleInfo.setReincarnationCount(this.et_reincarnationrCount.getText().toString());
                            roleInfo.setCharge(et_charge.getText().toString());
                            this.sdk.upLoadRoleInfo(Constants.UPLOADTYPE_LEVELUP, this, roleInfo);
                            stringBuilder2 = new StringBuilder();
                            stringBuilder2.append("roleInfo:=");
                            stringBuilder2.append(roleInfo.getAllParam().toString());
                            Toast.makeText(this, stringBuilder2.toString(), Toast.LENGTH_LONG).show();
                            break;
                        case R.id.user_btn /*2131034225*/:
                            JSONObject json = new JSONObject();
                            try {
                                json.put("AE", "xio");
                                json.put("AE5", "future");
                            } catch (JSONException e) {
                                e.printStackTrace();
                            }


                            sdk.reportAdEvent("Car", json);
                            break;
                    }
                    break;
            }
        } else {
            Toast.makeText(this, String.format("%010d", new Object[]{Long.valueOf(System.currentTimeMillis() / 1000)}), Toast.LENGTH_LONG).show();
        }

    }


    // 发送消息给Unity
    private void SendToUnity(String msg) {


    }

    public void binaryToDecimal2(int n) {
        String str = "";
        while (n != 0) {
            str = n % 2 + str;
            n = n / 2;
        }
        System.out.println(str);
    }

    public void binaryToDecimal(int n) {
        for (int i = 31; i >= 0; i--)
            System.out.print(n >>> i & 1);
    }

    @Override
    protected void onStart() {
        // TODO Auto-generated method stub
        sdk.sdkOnStart(MainActivity.this);

        super.onStart();
    }

    @Override
    protected void onStop() {
        // TODO Auto-generated method stub
        sdk.sdkOnStop(MainActivity.this);
        super.onStop();
    }

    @Override
    protected void onResume() {
        // TODO Auto-generated method stub
        super.onResume();
        sdk.sdkOnResume(MainActivity.this);
    }

    @Override
    protected void onDestroy() {
        // TODO Auto-generated method stub
        sdk.sdkOnDestroy(MainActivity.this);
        super.onDestroy();
//        System.exit(0);
    }

    @Override
    protected void onPause() {
        // TODO Auto-generated method stub
        super.onPause();
        sdk.sdkOnPause(MainActivity.this);
    }

    @Override
    protected void onRestart() {
        super.onRestart();
        sdk.sdkOnRestart(MainActivity.this);
    }


    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        // TODO Auto-generated method stub
        super.onActivityResult(requestCode, resultCode, data);
        sdk.onActivityResult(this, requestCode, resultCode, data);

    }


    @Override
    public void onBackPressed() {
        // TODO Auto-generated method stub
//            sdk.exitGame(MainActivity.this, new ExitCallback() {
//
//                @Override
//                public void onExit(boolean needExit) {
//                    // TODO Auto-generated method stub
//                    if (needExit) {
////                    System.exit(0);
//                        finish();
//                    }
//                }
//
//
//            });

    }


    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {

        if (keyCode == KeyEvent.KEYCODE_BACK) {
            sdk.exitGame(MainActivity.this, new ExitCallback() {

                @Override
                public void onExit(boolean needExit) {
                    // TODO Auto-generated method stub
                    if (needExit) {
//                    System.exit(0);
                        finish();
                    }
                }


            });
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        // TODO Auto-generated method stub
        super.onConfigurationChanged(newConfig);
        sdk.onConfigurationChanged(newConfig);
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);
        sdk.onWindowFocusChanged(this, hasFocus);
    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        sdk.sdkOnNewIntent(this, intent);
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        sdk.onRequestPermissionsResult(requestCode, permissions, grantResults);

    }


    public void callPhone(String phoneNum) {
        String url = "tel:" + "123456";
        Intent intent = new Intent();
        intent.setData(Uri.parse(url));
        intent.setAction(Intent.ACTION_DIAL);
        // 是否可以处理跳转到拨号的 Intent
        boolean canResolveIntent = intent.resolveActivity(this.getPackageManager()) != null;

        Log.i("canResolveIntent", canResolveIntent + "");
    }


    public static boolean judgeStrNull(String str) {
        return str == null || str.equals("");
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
    }

}