package com.yyrh.utils;

import android.util.Log;

import com.yyrh.constant.SDKSettings;

public class YYLog {

    protected static final String TAG = "YYLog";

    private YYLog() {
    }

    public static void d(String msg) {
        if (SDKSettings.isDebug)
            Log.d(TAG, buildMessage(msg));
    }

    public static void d(String msg, Throwable tr) {
        if (SDKSettings.isDebug)
            Log.d(TAG, buildMessage(msg), tr);
    }

    public static void v(String msg) {
        if (SDKSettings.isDebug)
            Log.v(TAG, buildMessage(msg));
    }
    public static void v(String msg, Throwable tr) {
        if (SDKSettings.isDebug)
            Log.v(TAG, buildMessage(msg));
    }

    public static void w(String msg) {
        if (SDKSettings.isDebug)
            Log.w(TAG, buildMessage(msg));
    }

    public static void w(Throwable ioe) {
        if (SDKSettings.isDebug)
            Log.w(TAG, ioe);
    }

    public static void w(String msg, Throwable e) {
        if (SDKSettings.isDebug)
            Log.w(TAG, buildMessage(msg), e);
    }

    public static void i(String msg) {
        if (SDKSettings.isDebug)
            Log.i(TAG, buildMessage(msg));
    }

    public static void i(String msg, Throwable tr) {
        if (SDKSettings.isDebug)
            Log.i(TAG, buildMessage(msg), tr);
    }

    public static void e(String msg) {
        if (SDKSettings.isDebug)
            Log.e(TAG, buildMessage(msg));
    }

    public static void e(String msg, Throwable tr) {
        if (SDKSettings.isDebug)
            Log.e(TAG, buildMessage(msg), tr);
    }

    /**
     * Building Message
     * @param msg The message you would like logged.
     * @return Message String
     */
    protected static String buildMessage(String msg) {
        StackTraceElement caller = new Throwable().fillInStackTrace().getStackTrace()[2];

        return new StringBuilder()
                .append(caller.getClassName())
                .append(".")
                .append(caller.getMethodName())
                .append("(): ")
                .append(msg).toString();
    }
}
